#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<vpii> vvpii;
typedef long long ll;
typedef long double ld;

template <class T> using Tree = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)(x).size()
#define fi first
#define se second

template<class T> bool ckmin(T &a, const T &b) {return a > b ? a = b, 1 : 0;}
template<class T> bool ckmax(T &a, const T &b) {return a < b ? a = b, 1 : 0;}

//DEBUG TEMPLATE POCINJE OVDE

void __print(int x) {cerr << x;}
void __print(long long x) {cerr << x;}
void __print(double x) {cerr << x;}
void __print(long double x) {cerr << x;}
void __print(char x) {cerr << '\'' << x << '\'';}
void __print(const string &x) {cerr << '\"' << x << '\"';}
void __print(bool x) {cerr << (x ? "true" : "false");}

template<typename T, typename V>
void __print(const pair<T, V> &x) {cerr << '{'; __print(x.first); cerr << ','; __print(x.second); cerr << '}';}
template<typename T>
void __print(const T &x) {int f = 0; cerr << '{'; for(auto z : x) cerr << (f++ ? "," : ""), __print(z); cerr << "}";}
void _print() {cerr << "]\n";}
template <typename T, typename... V>
void _print(T t, V... v) {__print(t); if(sizeof...(v)) cerr << ", "; _print(v...);}

#ifdef ljuba
#define debug(x...) cerr << "LINE(" << __LINE__ << ") -> " << "[" << #x << "] = ["; _print(x)
#else
#define debug(x...)
#endif

//DEBUG TEMPLATE SE ZAVRSAVA OVDE

const char nl = '\n';

const int mxN = 4e5 + 13;
const int MOD = 1e9 + 7;

int fact[mxN], fact2[mxN];

inline int add(int a, int b) {
    return (a + b) % MOD;
}

inline int mul(int a, int b) {
    return (a * 1LL * b) % MOD;
}

int modPow(int a, int b) {
    int ans = 1;
    while(b) {
        if(b&1)
            ans = mul(ans, a);
        a = mul(a, a);
        b /= 2;
    }
    return ans;
}

inline int inverz(int a) {
    return modPow(a, MOD-2);
}

int nck(int n, int k) {
    if(k > n)
        return 0;
    if(k == 0)
        return 1;

    int gore = fact[n];
    int dole = mul(fact2[k], fact2[n-k]);
    return mul(gore, dole);
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    fact[0] = 1;
    
    for(int i = 1; i < mxN; ++i) {
        fact[i] = mul(i, fact[i-1]);
        fact2[i] = inverz(fact[i]);
    }

    //debug(nck(5, 4));

    int n, k;
    cin >> n >> k;
    vi v(n);
    for(auto &z : v)
        cin >> z;

    if(k == 0) {
        int ans = 0;
        for(auto z : v)
            ans = add(ans, z);
        cout << ans << nl;
        return 0;
    }

    int ans = 0;

    for(int i = 0; i < n; ++i) {
        int nesto = mul(nck(k+i, i), nck(k+(n-1-i), n-1-i));
        //debug(nck(k+i, i), nck(k+(n-1-i), n-1-i));
        //debug(nesto);
        ans = add(ans, mul(nesto, v[i]));
    }

    cout << ans << nl;
    
}